//---------------------------------------------------------------------------
#include <stdio.h>
#include <stdlib.h>
#include <dir.h>

#include <vcl.h>
#pragma hdrstop

#include "editeur.h"
#include "Unit_aide.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CSPIN"
#pragma resource "*.dfm"
TForm1 *Form1;


#define NB_ENN_MAX 100 // nombre d'ennemi maximun pour un niveau

// ---------- STRUCTURES ---------- //
typedef struct {
        float tps;      // temps d'apparition de l'ennemi
        char *nom;      // nom de l'ennemi
        //AnsiString nom;
        float x,y;      // coordonnes en x et en y de l'ennemi
} s_ennemi;

typedef struct {
        //char nom[20];           // nom du niveau
        AnsiString nom;
        int profondeur;                 // apparition des ennemis en Z
        int duree;                      // duree totale du niveau
        int nbEnn;                      // nombre totale d'ennemi du niveau
        s_ennemi enn[NB_ENN_MAX];       // tableau d'ennemi
} s_niveau;


s_niveau nivo;

int dureeMiss;
int tpsT;
bool bgCharger = false;
Graphics::TBitmap *background = new Graphics::TBitmap(); // fond

//bool dejaEnr = false;

//-------------------------------------------------------------------+
//  fonction qui convertit un AnsiString de m.... en char * de m.... |
//  si vous voulez convertir tout l'AnsiString, mettre nbcar  0     |
//-------------------------------------------------------------------+
char * AnsiToCharEtoile (AnsiString str, int nbcar)
{
 char *ch;
 // 20 est le nombre maximun de caractere convertit
 if ( nbcar <= 0 )       nbcar = 255;

 ch = (char *) malloc ( nbcar*sizeof(char) );

 // * ecrire le nom dans un fichier tmp * //
 FILE *tmp;
 tmp = fopen ( "ennemi.tmp", "w" );
 fprintf( tmp, "%s", str);
 fclose( tmp );

 tmp = fopen ( "ennemi.tmp", "r" );
 fgets ( ch, nbcar, tmp );
 fclose( tmp );

 // * suppression du fichier temporaire * //
 remove( "ennemi.tmp" );

 return ch;
}

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------


void __fastcall TForm1::GrilleMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  int dim=32;  // dimension d'un icone -> 32*32
  int x, y; // coordonnes
  int epaisseurX, epaisseurY;
  long colonne, ligne;
  Graphics::TIcon *icone = new Graphics::TIcon();

  //Grille->MouseToCell (X, Y, colonne, ligne );

  colonne = Grille->Col;
  ligne   = Grille->Row;

  // si il ya deja 50 ennemis alors on ne peut plus en rajouter
  if (nivo.nbEnn < NB_ENN_MAX)
  {
        // si il y a un icone slectionn ...
        if ( fichiers->FileName.Length( ) != 0 )
        {
                icone->LoadFromFile ( fichiers->FileName );
                x = Grille->Selection.TopLeft.X;
                y = Grille->Selection.TopLeft.Y;
                epaisseurX = x*Grille->GridLineWidth;
                epaisseurY = y*Grille->GridLineWidth;
                Grille->Canvas->Draw (x*dim + epaisseurX,y*dim + epaisseurY, icone);
                delete icone;// icone->Free( );
                // on recupere toutes les valeurs dans la structure de niveau ...
                nivo.enn[nivo.nbEnn].x   = Grille->Col - 5;
                nivo.enn[nivo.nbEnn].y   = - Grille->Row + 5;

                int pos = fichiers->Items->Strings[fichiers->ItemIndex].Pos(".ico") ;
                nivo.enn[nivo.nbEnn].nom = AnsiToCharEtoile ( fichiers->Items->Strings[fichiers->ItemIndex], pos );

                nivo.enn[nivo.nbEnn].tps = tempsT->Value;
                nivo.nbEnn ++;
                labelNbEnn->Caption = "nombre total d'ennemis : " + IntToStr( nivo.nbEnn ) + "/" + IntToStr ( NB_ENN_MAX );
        }
  }
  else
        ShowMessage (AnsiString ("Trop d'ennemis tue l'ennemi !") );
}
//---------------------------------------------------------------------------


void __fastcall TForm1::fichiersChange(TObject *Sender)
{
 int taille;
//ShowMessage ( fichiers->FileName );

  taille = fichiers->FileName.Length(  );
  if (taille != 0)
        Icone->Picture->LoadFromFile( fichiers->FileName );
}
//---------------------------------------------------------------------------



void __fastcall TForm1::FormCreate(TObject *Sender)
{

//     ChangeDir ( CurrentDir & "\icones");

 // initialisation de certaines valeurs de la structure nivo ...
 nivo.nbEnn = 0;
 nivo.duree = 100;
 nivo.nom = NomNiveau->Caption;
 nivo.profondeur = -100;

 labelNbEnn->Caption = "nombre total d'ennemis : " + IntToStr( nivo.nbEnn ) + "/" + IntToStr ( NB_ENN_MAX );

}

//----------------------------------------+
// procedure d"enregistrement d'un niveau |
//----------------------------------------+
void enregistrement (AnsiString ansiSTR)
{
  int i;
  char *nomfic;
  FILE *fic;

  // on teste que les temps d'apparition soit bien
  // infrieur a la dure de la mission ...
  for (i=0;i<nivo.nbEnn;i++)
  {
        if (nivo.enn[i].tps > nivo.duree)
                  ShowMessage (AnsiString ("des temps d'apparition son superieur a la dure totale !") );
  }

  nomfic = AnsiToCharEtoile (ansiSTR, 0);
  fic = fopen ( nomfic, "w" );
  fprintf( fic, "%s\n%d\n%d\n", nivo.nom, nivo.duree, nivo.nbEnn);
  for (i=0;i<nivo.nbEnn;i++)
  {
        fprintf( fic, "%d\t%0.2f\t%s\t",i, nivo.enn[i].tps, nivo.enn[i].nom);
        fprintf( fic, "%0.2f\t%0.2f\t%d\n", nivo.enn[i].x, nivo.enn[i].y, nivo.profondeur );
  }
  fclose( fic );
}

//---------------------------------------------------------------------------

void __fastcall TForm1::NomNiveauClick(TObject *Sender)
{
  nivo.nom = InputBox("Choix du nom pour le niveau", "Entrer un nom : ", NomNiveau->Caption);
  NomNiveau->Caption = nivo.nom;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Enregistrerleniveausous2Click(TObject *Sender)
{
  int i;
  char *nomfic;
  FILE *fic;

  // on teste que les temps d'apparition soit bien
  // infrieur a la dure de la mission ...
  for (i=0;i<nivo.nbEnn;i++)
  {
        if (nivo.enn[i].tps > nivo.duree)
                  ShowMessage (AnsiString ("des temps d'apparition son superieur a la dure totale !") );
  }

  if(SaveDialog1->Execute())
  {
        nomfic = AnsiToCharEtoile (SaveDialog1->FileName, 0);

        // test si nom du fichier contient deja l'extension souhaite
        if (AnsiStrPos(nomfic,".txt") == NULL)
        {
            SaveDialog1->FileName = SaveDialog1->FileName + ".txt";
            nomfic = AnsiToCharEtoile (SaveDialog1->FileName, 0);
        }

        ShowMessage ( AnsiString("Niveau enregistr avec succs sous : \n") + nomfic );
        fic = fopen ( nomfic, "w" );
        fprintf( fic, "%s\n%d\n%d\n", nivo.nom, nivo.duree, nivo.nbEnn);
        for (i=0;i<nivo.nbEnn;i++)
        {
                fprintf( fic, "%d\t%0.2f\t%s\t",i, nivo.enn[i].tps, nivo.enn[i].nom);
                fprintf( fic, "%0.2f\t%0.2f\t%d.00\n", nivo.enn[i].x, nivo.enn[i].y, nivo.profondeur );
        }
        fclose( fic );
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Enregistrer1Click(TObject *Sender)
{
 // si le il y a pas encore eu d'enregistrement sous ...
 if ( SaveDialog1->FileName == "" )
 {
        Enregistrerleniveausous2Click(Form1) ;
 }
 else   // appel la fonction d'enregistrement sans la boite de dialogue
        enregistrement ( SaveDialog1->FileName );

}
//---------------------------------------------------------------------------

void __fastcall TForm1::background1Click(TObject *Sender)
{
  if ( OuvrirBMP->Execute() )
  {
        Grille->Canvas->Brush->Color = clRed;
        background->LoadFromFile (OuvrirBMP->FileName);
        bgCharger = true;
        Grille->Canvas->Draw (0, 0, background);
        Grille->Repaint( );
  }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::DureeMissionExit(TObject *Sender)
{

  if ( DureeMission->Text == "")
      DureeMission->Text = dureeMiss;

  nivo.duree =  StrToInt ( DureeMission->Text ) ;
  tempsT->MaxValue = StrToInt ( DureeMission->Text ) ;

  // on rinitialise correctement
  if ( tempsT->Value > tempsT->MaxValue )
        tempsT->Value = tempsT->MaxValue;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::DureeMissionEnter(TObject *Sender)
{
  // on stocke la valeur contenue avant l'entrer du curseur
  dureeMiss = StrToInt ( DureeMission->Text ) ;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::tempsTEnter(TObject *Sender)
{
  tpsT = tempsT->Value;
}
//---------------------------------------------------------------------------



void __fastcall TForm1::Aide1Click(TObject *Sender)
{
 Faide->ShowModal( );        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::changerlaprofondeur1Click(TObject *Sender)
{
  AnsiString profondeur;
  profondeur = InputBox("Apparition des ennemis", "Profondeur en z ( -10<...<-100 ) : ", nivo.profondeur);
  nivo.profondeur = StrToInt ( profondeur );
}
//---------------------------------------------------------------------------

void __fastcall TForm1::effacementClick(TObject *Sender)
{
    Grille->Canvas->FloodFill( 1, 1, clRed , fsBorder);
    if ( bgCharger == true )
    {
       background->LoadFromFile (OuvrirBMP->FileName);
       Grille->Canvas->Draw (0, 0, background);
    }
    Grille->Repaint( );
}
//---------------------------------------------------------------------------

void __fastcall TForm1::tempsTExit(TObject *Sender)
{
  if ( ( tempsT->Value < 0 )||( tempsT->Value > tempsT->MaxValue ) )
  {
        tempsT->Value = tpsT;
  }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::tempsTChange(TObject *Sender)
{
 // teste qu'il y est tjs une valeur dans la case
 if ( tempsT->Text == "")
    tempsT->Value = tpsT;

 if ( tempsT->Value > tempsT->MaxValue )
    tempsT->Value = tempsT->MaxValue;

 if (tempsT->Value != tpsT) effacementClick( Grille );

}
//---------------------------------------------------------------------------



void __fastcall TForm1::Quitter1Click(TObject *Sender)
{
        Form1->Close( );        
}
//---------------------------------------------------------------------------


